
// CREATE AN ARRAY OF DEPARTMENTS ------------------------------------------
var Departments = ["Marketing", "Engineering", "Human Resource", "Sales", "Customer Services", "Admin", "IT", "Security"];
var totalDepartments = Departments.length;
// alert("Total Number of Departments: " + totalDepartments);
// CREATE AN  ARRAY OF EMPLOYEE OBJECTS -------------------------------------
var Employees = [
{firstName:"Ann", lastName:"Ricoh", department:"Marketing", city:"Austin", state:"Texas", startDate:"1/12/16", image:"ann_ricoh.jpg"},
{firstName:"Bob", lastName:"Anderson", department:"Human Resource", city:"Round Rock", state:"Texas", startDate:"2/13/16", image:"bob_anderson.jpg"},
{firstName:"Carol", lastName:"Green", department:"Security",  city:"Pflugerville", state:"Texas", startDate:"3/14/16", image:"carol_green.jpg"},
{firstName:"Debra", lastName:"Samson", department:"IT", city:"Cedar Park",  state:"Texas", startDate:"4/15/16", image:"debra_samson.jpg"}
];
// alert("First name of first employee: " + Employees[0].firstName);
var numberOfEmployees = Employees.length;
// alert("Total Number of Employees is: " + numberOfEmployees);
$(document).ready(function(e) {
// CREATE A  GENERIC FUNCTION THAT WILL CREATE AND  REFRESH THE LISVIEW -----------------
createListView();

function createListView()
{
  for(i=0;i<numberOfEmployees;i++)
  {
    // alert(Employees[i].firstName + " " +  Employees[i].lastName + ": " + Employees[i].department);
    var fullName =  Employees[i].firstName + " " + Employees[i].lastName;
var imageDirAndName = "images/" + Employees[i].image;
var department = Employees[i].department;
// If NO image is selected than provide default avatar image
if (imageDirAndName == "images/")
{
  imageDirAndName = "images/photo_not_available_large.png";
}
// alert (imageDirAndName);
$("#myList").append("<li><a href='#employee_page'><img src=" +  imageDirAndName  + " width='307' height='240' alt=''/><h3 style='color:orange'>" +  fullName + "</h3><p>" +  department + "</p></a><a id='edit'  href='#'>Edit " + fullName + "</a></li>");
// Once a ListView is manipulated, it has to  be REFRESHED to see the updated appearance.
$("#myList").listview("refresh");   
      
  }
}

// VIEW SELECTED INDEX FROM LISTVIEW -------------------------------------------
$(document).on("click", "#myList li a", function() {
selectedIndex = $(this).closest("li").index();
//alert("The selected index when the view button is clicked: " +  selectedIndex);
$("#imageID").hide();
$("#imageID_Label").hide();
$("#imageID2").show();
$("#imageID2_Label").show();
var currentImage  = "images/" + Employees[selectedIndex].image;   
var fullName = Employees[selectedIndex].firstName + " " + Employees[selectedIndex].lastName;
var city = Employees[selectedIndex].city;
var state = Employees[selectedIndex].state;
var startDate = Employees[selectedIndex].startDate;
var department = Employees[selectedIndex].department;
// alert(currentImage);
// If NO image  is selected than provide default avatar image
if (currentImage == "images/")
{
  currentImage = "images/photo_not_available_large.png";
}         
// The method replaceWith() did not work so we had to add the empty() and  append() methods
$("#employee_page div#container").empty();

$("#employee_page div#container").append("<img  style='border:1px solid black' src= '" + currentImage + "'  width='307' height='240' alt=''/>");
$("#employee_page div#container").append("<h1 style = 'color:red'>" + fullName + "</h1>");
$("#employee_page div#container").append("<p><strong  style = 'color:red'>City:</strong> " + city + "</p>");
$("#employee_page div#container").append("<p><strong  style = 'color:red'>State:</strong> " + state +  "</p>");
$("#employee_page div#container").append("<p><strong  style = 'color:red'>Start Date:</strong> " + startDate + "</p>");
$("#employee_page div#container").append("<p><strong  style = 'color:red'>Department:</strong> " + department + "</p>");  

$("#delete_dialog_page div#container2").empty();	
$("#delete_dialog_page div#container2").append("<p>Are you sure you want to delete " + fullName + "?</p>");  
});
    
// HIDE ADD  EMPLOYEE FORM, BUTTONS, ETC.  --------------------------------------
$("#add_employee_form").hide();
$("#add_employee_btn").hide();
$("#cancel_add_employee_btn").hide();
$("#edit_employee_btn").hide();
// ANIMATE ADD  EMPLOYEE FORM WHEN CLICKED  --------------------------------------
$("#show_add_employee_form").click(function()
{
$(this).hide();
$("#imageID").show();
$("#imageID_Label").show();
$("#imageID2").hide();
$("#imageID2_Label").hide();
$("#add_employee_form").slideDown(500);
$("#add_employee_btn").show();
$("#cancel_add_employee_btn").show();
});  
// CANCEL ADD EMPLOYEE BUTTON FUNCTIONALITY  ------------------------------------
$("#cancel_add_employee_btn").click(function(e){
closeForm();
});
function closeForm()
{
$("#add_employee_form").slideUp(500);
$("#show_add_employee_form").show();
$("#firstNameID").val("");
$("#lastNameID").val("");
$("#startDateID").val("");
$("#imageID").val("");
$("#add_employee_btn").hide();
$("#cancel_add_employee_btn").hide();
$("#edit_employee_btn").hide();
}
// ADD EMPLOYEE  BUTTON FUNCTIONALITY -----------------------------------------
$("#add_employee_btn").click(function(e){
numberOfEmployees++
var firstNameField = $("#firstNameID").val();
var lastNameField = $("#lastNameID").val();
var cityField = $("#cityID").val();
var stateField = $("#stateID").val();
var startDateField = $("#startDateID").val();
var departmentField = $("#departmentID").val();
var imageField = $("#imageID").val();

Employees.push({firstName:firstNameField, lastName:lastNameField, city:cityField, state:stateField, startDate:startDateField,  department:departmentField, image:imageField});
    
// alert("What is first name? " + Employees[0].firstName);
// alert("Number of Employees: " + Employees.length);
$("#myList").empty(); // Clear ListView
createListView(); // Recreate ListView
closeForm(); // Close Form

})

// OPEN AND PREPOPULATE ADD EMPLOYEE FORM FOR EDITING ---------------------------------------

$(document).on("click", "#myList li a#edit", function() {

$("#add_employee_form").slideDown();
$("#show_add_employee_form").hide();
$("#cancel_add_employee_btn").show();
$("#edit_employee_btn").show();

$("#firstNameID").val(Employees[selectedIndex].firstName);
$("#lastNameID").val(Employees[selectedIndex].lastName);
$("#cityID").val(Employees[selectedIndex].city);
$("#stateID").val(Employees[selectedIndex].state);
$("#startDateID").val(Employees[selectedIndex].startDate);

$("#departmentID").val(Employees[selectedIndex].department);
$("#imageID2").val(Employees[selectedIndex].image); 
$("#departmentID").empty(); // Empty combo box first and then refill it with loop
  for(var i=0; i<totalDepartments; i++)
{
var DepartmentArray = Departments[i];
var EmployeeCurrentTitle = Employees[selectedIndex].department;
// alert("Current Title: " + EmployeeCurrentTitle + "; " + "Dept Array is: " + DepartmentArray);

if(EmployeeCurrentTitle == DepartmentArray)
{
// alert("Match Found") 
$("#departmentID").append("<option selected='selected'>" + EmployeeCurrentTitle + "</option>");
}

if(EmployeeCurrentTitle != DepartmentArray)
{
// alert("Match Not Found")
$("#departmentID").append("<option>" + DepartmentArray + "</option>");
}

// refresh and force rebuild of the combo box
$("#departmentID").selectmenu("refresh", true);  
    
}
});  
    
// SAVE UPDATES  BUTTON FUNCTIONALITY -------------------------

$("#edit_employee_btn").click(function(e){

Employees[selectedIndex].firstName = $("#firstNameID").val();
Employees[selectedIndex].lastName = $("#lastNameID").val();
Employees[selectedIndex].city = $("#cityID").val();
Employees[selectedIndex].state = $("#stateID").val();
Employees[selectedIndex].startDate = $("#startDateID").val();
Employees[selectedIndex].department = $("#departmentID").val();
Employees[selectedIndex].image = $("#imageID2").val();

$("#myList").empty();  // Clear ListView
createListView(); // Recreate  ListView
closeForm(); // Close Form
});

// DELETE EMPLOYEE BUTTON FUNCTIONALITY --------------------------------------------
//$("#delete_employee_btn").click(function(e){
//
//var choose = confirm("Are you sure you want to delete this employee?");
//
//if (choose == true) {
////  alert("You pressed the OK button!");
//Employees.splice(selectedIndex,1); // Remove selectedItem form Employees array
//$("#myList li").eq(selectedIndex).remove(); // Remove selectedItem from ListView
//window.location.href = "#home_page"; // Return to Master Page (e.g., home_page)
//} 
//else
//{
//// alert("You pressed the Cancel button!");
//window.location.href = "#home_page";
//}
//
//});
	
	$("#confirm_delete").click(function(e){ 
	Employees.splice(selectedIndex,1); 
	// Remove selectedItem form Employees array 
		$("#myList li").eq(selectedIndex).remove(); 
		// Remove selectedItem from ListView 
		window.location.href = "#home_page"; 
		// Return to Master Page (e.g., home_page) 
		// store array to localstorage 
		localStorage.setItem("list_data_key", JSON.stringify(Employees)); 
	  }); // end of confirm delete 

    
}); // END OF DOCUMENT.READY() FUNCTIONALITY	


